/***************************************************************************
 *   Copyright (C) 2010 by Rico Rommel   *
 *   rico@bierrommel.de   *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
 ***************************************************************************/
#ifndef OMBATTERY_H
#define OMBATTERY_H

#include <QWidget>
#include <QDBusInterface>
#include <QTableWidget>
#include <QTimer>
#include <QDBusReply>
#include <QVBoxLayout>
#include <QHBoxLayout>
#include <QLabel>
#include <QPushButton>
#include <QSystemTrayIcon>
#include <ominfobox.h>
#include <ombatteryinterface.h>
#include <omdialogbuttons.h>

/**
	@author Rico Rommel <rico@bierrommel.de>
*/
class OMBattery : public QWidget
{
Q_OBJECT
public:
    OMBattery(QWidget *parent = 0);

    ~OMBattery();
    void connectToBattery();
    QString secToHMS(int sec );
    void setBatteryIcon();

protected:
    QDBusInterface * BatteryInterface;
    QTimer * Timer;
    QVBoxLayout * MainLayout;
    QStringList properties;
    QLabel labels[10][2];
    QString NAString;
    int BatteryCharge;
    bool BatteryCharging;
    QString IconBasePath;
    QSystemTrayIcon * SysTrayIcon;
    OMInfoBox * InfoBox;
    OMDialogButtons * DialogButtons;

public slots:
    void update();

protected slots:
    void iconActivated(QSystemTrayIcon::ActivationReason);
    void PowerStatuschanged ( QString status );
    void Capacitychanged ( int cap );
    void DialogButtonClicked(QFlags<OMFlags::Flag> button);

};

#endif
