/***************************************************************************
 *   Copyright (C) 2010 by Rico Rommel   *
 *   rico@bierrommel.de   *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
 ***************************************************************************/
#ifndef OMGSM_H
#define OMGSM_H

#include <QWidget>
#include <QStringList>
#include <QIcon>
#include <QList>
#include <QSystemTrayIcon>
#include <QVBoxLayout>
#include <QHBoxLayout>
#include <QPushButton>
#include <QTabWidget>
#include <ominfobox.h>
#include <omconfig.h>
#include <QDBusReply>
#include <QDBusInterface>
#include <QDBusConnection>
#include <QDBusArgument>
#include "omusageinterface.h"
#include <omdialogbuttons.h>
/**
	@author Rico Rommel <rico@bierrommel.de>
*/
class OMGSM : public QWidget
{
Q_OBJECT
public:
    OMGSM(QWidget *parent = 0);

    ~OMGSM();
    void updateDeviceInfo();
    void getSIMInfo();
    void updateNetworkInfo();

protected:
    QString IconBasePath;
    QStringList IconFiles;
    QList<QIcon> Icons;
    QSystemTrayIcon * SysTrayIcon;
    QVBoxLayout * MainLayout;
    QTabWidget * TabWidget;
    OMInfoBox * GSMInfoBox;
    OMInfoBox * GPRSInfoBox;
    QDBusInterface * NetworkInterface;
    QDBusInterface * SIMInterface;
    QDBusInterface * DeviceInterface;
    OMUsageInterface * UsageInterface;
    QDBusConnection *systemBus;
    QString GSMNumberPanelName;
    QString GSMIMEIPanelName;
    QString GSMModelPanelName;
    QString GSMProviderPanelName;
    QString GSMModePanelName;
    QString GSMStrengthPanelName;
    OMDialogButtons *DialogButtons;
//    OMConfig * GSMConfiguration;
  //  OMConfig * GPRSConfiguration;


protected slots:
    void iconActivated(QSystemTrayIcon::ActivationReason);
    void connectToDeviceInterface();
    void connectToSIMInterface();
    void connectToNetworkInterface();
    void ReadyStatuschanged(bool status);
    void ResourceChanged(QString device, bool status);
    void connectToUsageInterface();
    void NetworkStatusChanged();
    void DialogButtonClicked(QFlags<OMFlags::Flag> button);

};

#endif
