/***************************************************************************
 *   Copyright (C) 2009 by Rico Rommel   *
 *   rico@bierrommel.de   *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
 ***************************************************************************/


#include <omapplication.h>
#include <QDBusConnection>
#include <QDBusInterface>
#include <QDBusReply>
#include "idlehandler.h"

int main(int argc, char *argv[])
{
      	OMApplication app(argc, argv);

	QDBusConnection SessionBus(QDBusConnection::sessionBus());

	if (SessionBus.isConnected()) { 

		QDBusInterface *sessioninterface = new QDBusInterface(SERVICENAME, "/","",SessionBus, 0);
		if (sessioninterface->isValid()) {
//			QDBusReply<bool> reply;
//			reply = sessioninterface->call("activate");
			qDebug() << "idlehandler is already running. stop.";
			sessioninterface->call("activate");
			return 0;
		}
		else {
			IdleHandler *mw = new IdleHandler(&SessionBus);

     				mw->hide();
     				return app.exec();
			}

		

	} else { 
		qDebug() << "cannot connect to Session Bus";
		return 1;
		}
}

/*
		
		//läuft idlehandler schon?
		sessioninterface = new QDBusInterface(SERVICENAME, "/","",QDBusConnection::sessionBus(), this);

		if (sessioninterface->isValid()) {
			QDBusReply<bool> reply;
			reply = sessioninterface->call("testRunning");
			if (reply.value()) return 1;				
			}
		else qDebug() << "error:" << SessionBus.lastError().message();
*/		