/***************************************************************************
 *   Copyright (C) 2010 by Rico Rommel   *
 *   rico@bierrommel.de   *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
 ***************************************************************************/
#include "omkeyboard.h"
#include <QDebug>

OMKeyboard::OMKeyboard(QWidget *parent)
 : QWidget(parent)
{
	KeyboardApp = "/usr/bin/matchbox-keyboard";

	IconBasePath = "/usr/share/pixmaps/openmoko-panel-plugin-qt/";
	activeIconFile = "matchbox-keyboard_1.png";
	inactiveIconFile = "matchbox-keyboard_0.png";

	activeIcon = QIcon(IconBasePath + activeIconFile);
	inactiveIcon = QIcon(IconBasePath + inactiveIconFile);

	SysTrayIcon = new QSystemTrayIcon( inactiveIcon, this );
	connect(SysTrayIcon, SIGNAL(activated(QSystemTrayIcon::ActivationReason)),this, SLOT(iconActivated(QSystemTrayIcon::ActivationReason)));
	SysTrayIcon->show();
	
	KeyboardProcess = new QProcess( this );

	Settings = new QSettings("openmoko","openmoko-panel-plugin-qt-keyboard",this);

	loadSettings();

}


OMKeyboard::~OMKeyboard()
{
	saveSettings();
}



void OMKeyboard::iconActivated(QSystemTrayIcon::ActivationReason)
{
	if (KeyboardProcess->state() == QProcess::Running) {
		KeyboardProcess->close();
		SysTrayIcon->setIcon( inactiveIcon );
		}

	else {
		KeyboardProcess->start(KeyboardApp );
		SysTrayIcon->setIcon( activeIcon );
		
		}
}


void OMKeyboard::loadSettings()
{
    	QString tmp = Settings->value("command").toString();
	if (!tmp.isEmpty()) KeyboardApp=tmp;
	else saveSettings();

}


void OMKeyboard::saveSettings()
{
	Settings->setValue("command",KeyboardApp);

}
