/***************************************************************************
 *   Copyright (C) 2010 by Rico Rommel   *
 *   rico@bierrommel.de   *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
 ***************************************************************************/

#include "ombatteryinterface.h"


QString OMBatteryPath()
{
	QDBusInterface PowerSupplyInterface("org.freesmartphone.odeviced", "/org/freesmartphone/Device/PowerSupply", "org.freedesktop.DBus.Introspectable", QDBusConnection::systemBus(), 0);
	
	if (!PowerSupplyInterface.isValid()) { qDebug() << "Cannont connect to powersupply interface. Bye..";}

	QDBusReply <QString> xml = PowerSupplyInterface.call("Introspect");

//	qDebug() << xml;

	QDomDocument data;
	data.setContent(xml);
	QDomElement node = data.documentElement();
      	QDomElement child = node.firstChildElement();

	bool batteryfound = false;
	QString BatteryPath = "";

	while (!child.isNull() && !batteryfound) {
		if (child.tagName() == "node") {
			
			qDebug() << "probing /org/freesmartphone/Device/PowerSupply/" + child.attribute("name");

			QDBusInterface BatteryInterface ("org.freesmartphone.odeviced", "/org/freesmartphone/Device/PowerSupply/" + child.attribute("name"), "org.freesmartphone.Device.PowerSupply", QDBusConnection::systemBus(), 0);
			
			QDBusReply< QMap < QString,QVariant> > reply = BatteryInterface.call("GetInfo");
			if (reply.value().value("name").toString() == "battery") {
				batteryfound=true; 
				BatteryPath = BatteryInterface.path(); 
				}
			}
		child = child.nextSiblingElement();
		}

	if (batteryfound) qDebug() << "battery found at " << BatteryPath;
	else qDebug() << "battery no found";

	return BatteryPath;
}


