/***************************************************************************
 *   Copyright (C) 2010 by Rico Rommel   *
 *   rico@bierrommel.de   *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
 ***************************************************************************/
#include "omscriptwidget.h"

OMScriptWidget::OMScriptWidget(QString name, QSettings *settings, QWidget *parent)
 : QWidget(parent)
{
	Settings = settings;
	ScriptName = name;
	MainLayout = new QHBoxLayout();

	CheckButton = new OMCheckButton( name, this );
	MainLayout->addWidget( CheckButton );

	LineEdit = new QLineEdit(this);
	MainLayout->addWidget( LineEdit );
	
	setLayout( MainLayout );

	connect(CheckButton, SIGNAL(stateChanged( bool )), this, SLOT(stateChanged( bool )));

	loadSettings();

}


OMScriptWidget::~OMScriptWidget()
{
}



void OMScriptWidget::stateChanged(bool newstate)
{
    LineEdit->setEnabled( newstate );
}


void OMScriptWidget::loadSettings()
{
    	Settings->beginGroup(ScriptName);
	CheckButton->setCheckState(Settings->value("enabled").toBool());
	QString tmp = Settings->value("command").toString();
	if (!tmp.isEmpty()) {
		LineEdit->setText(tmp);
		}
	else CheckButton->setCheckState(false);
	Settings->endGroup();
	
}


void OMScriptWidget::saveSettings()
{
    	Settings->beginGroup(ScriptName);
	Settings->setValue("enabled",CheckButton->isChecked());
	Settings->setValue("command",LineEdit->text());
	Settings->endGroup();
	
}

QString OMScriptWidget::script()
{
    return LineEdit->text();
}
